/* SPARC v8 gmp-mparam.h -- Compiler/machine parameter header file.

Copyright 1991, 1993, 1994, 1999, 2000, 2001, 2002 Free Software Foundation,
Inc.

This file is part of the GNU MP Library.

The GNU MP Library is free software; you can redistribute it and/or modify
it under the terms of the GNU Lesser General Public License as published by
the Free Software Foundation; either version 2.1 of the License, or (at your
option) any later version.

The GNU MP Library is distributed in the hope that it will be useful, but
WITHOUT ANY WARRANTY; without even the implied warranty of MERCHANTABILITY
or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU Lesser General Public
License for more details.

You should have received a copy of the GNU Lesser General Public License
along with the GNU MP Library; see the file COPYING.LIB.  If not, write to
the Free Software Foundation, Inc., 59 Temple Place - Suite 330, Boston,
MA 02111-1307, USA. */


#define BITS_PER_MP_LIMB 32
#define BYTES_PER_MP_LIMB 4

/* These numbers were obtained on kotov.sics.se, a 40MHz SuperSPARC system */

/* Generated by tuneup.c, 2002-02-17, gcc 2.8 */

#define MUL_KARATSUBA_THRESHOLD          14
#define MUL_TOOM3_THRESHOLD             105

#define SQR_BASECASE_THRESHOLD            6
#define SQR_KARATSUBA_THRESHOLD          30
#define SQR_TOOM3_THRESHOLD             173

#define DIV_SB_PREINV_THRESHOLD               0  /* always */
#define DIV_DC_THRESHOLD                     54
#define POWM_THRESHOLD                  125

#define GCD_ACCEL_THRESHOLD               3
#define GCDEXT_THRESHOLD                 13
#define JACOBI_BASE_METHOD                2

#define DIVREM_1_NORM_THRESHOLD           0  /* always */
#define DIVREM_1_UNNORM_THRESHOLD     MP_SIZE_T_MAX  /* never */
#define MOD_1_NORM_THRESHOLD              0  /* always */
#define MOD_1_UNNORM_THRESHOLD        MP_SIZE_T_MAX  /* never */
#define USE_PREINV_DIVREM_1               1
#define USE_PREINV_MOD_1                  1
#define DIVREM_2_THRESHOLD                0  /* always */
#define DIVEXACT_1_THRESHOLD              0  /* always */
#define MODEXACT_1_ODD_THRESHOLD          0  /* always */

#define GET_STR_DC_THRESHOLD       38
#define GET_STR_PRECOMPUTE_THRESHOLD     47
#define SET_STR_THRESHOLD              3524

#define MUL_FFT_TABLE  { 432, 1056, 1664, 4608, 14336, 40960, 0 }
#define MUL_FFT_MODF_THRESHOLD          448
#define MUL_FFT_THRESHOLD              4352

#define SQR_FFT_TABLE  { 400, 992, 1664, 4608, 14336, 40960, 0 }
#define SQR_FFT_MODF_THRESHOLD          416
#define SQR_FFT_THRESHOLD              3840
