import sys
from distutils.core import setup, Extension

if sys.version.find('MSC')==-1:
    gmpy_ext = Extension('gmpy', sources=['src/gmpy.c'],
        # library_dirs=['/usr/local/lib'],
        libraries=['gmp'])
else:
    gmpy_ext = Extension('gmpy', sources=['src/gmpy.c'],
        include_dirs=['./src'])

setup (name = "gmpy",
       version = "1.0",
       description = "GMP-3 to Python-2 interface",
       maintainer = "Alex Martelli",
       maintainer_email = "aleaxit@yahoo.com",
       url = "http://gmpy.sourceforge.net/",
       
       ext_modules = [ gmpy_ext ]
)
