import sage.pari.py_pari
pari = sage.pari.py_pari.pari

prime = sage.pari.py_pari.nth_prime

execute = sage.pari.py_pari.execute

###########################################
# Miscellaneou
###########################################
def exp(x):
    return pari(x).exp()

def factorial(n):
    return sage.pari.py_pari.factorial(int(n))

def log(x):
    return pari(x).log()

def polcoeff(f, n, v=-1):
    return pari(f).polcoeff(n,v)

def vector(x):
    """
    0 vector of length x if x is an integer,
    or PARI vector of entries of x, where x is a python list
    """
    if isinstance(x, (int,long)):
        if x < 0:
            raise ArithmeticError, "Vectors must have nonnegative length."
        return sage.pari.py_pari.vector(x)
    x = list(x)
    v = vector(len(x))
    for i in xrange(len(x)):
        v[i] = x[i]
    return v

def euler():
    return sage.pari.py_pari.euler()

def zeta(n):
    return pari(n).zeta()

###########################################
# 2: CONVERSIONS and similar elementary functions
###########################################

def Col(x): return pari(x).Col()

def List(x):
    return pari(x).List()

def Mat(x):
    return pari(x).Mat()

def Mod(x, y):
    return pari(x).Mod(pari(y))

def Pol(x):
    return pari(x).Pol()

def Polrev(x):
    return pari(x).Polrev()

def Qfb(a, b, c):
    """
        The method notation is awkward, so one can also use functional
        notation.
            >>> Qfb(3, 7, 2)
            Qfb(3, 7, 2, 0.E-288)
    """
    return pari(a).Qfb(pari(b),pari(c))

def floor(x):
    return pari(x).floor()


###########################################
# 4: NUMBER THEORETICAL functions
###########################################


###########################################
# 5: Functions related to ELLIPTIC CURVES
###########################################
def ellinit(ainvs, flag=0):
    return pari(ainvs).ellinit(flag=flag)

def ellan(e, n):
    return pari(e).ellan(n)

def ellap(e, p):
    return pari(e).ellap(pari(p))
