"""
Coercion helper functions
"""

#*****************************************************************************
#       Copyright (C) 2004 William Stein <was@math.harvard.edu>
#
#  Distributed under the terms of the GNU General Public License (GPL)
#
#    This code is distributed in the hope that it will be useful,
#    but WITHOUT ANY WARRANTY; without even the implied warranty of
#    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
#    General Public License for more details.
#
#  The full text of the GPL is available at:
#
#                  http://www.gnu.org/licenses/
#*****************************************************************************
 
def __coerce_best(x, y):
    if hasattr(x, "parent"):
        try:
            return x, x.parent()(y)
        except:
            if hasattr(y, "parent"):
                try:
                    return y.parent()(x), y
                except:
                    raise TypeError,\
                "Unable able to coerce %s (%s) and %s (%s) to common parent."%(
                        x,type(x),y,type(y))
    if hasattr(y, "parent"):
        try:
            return y.parent()(x), y
        except:
            pass
    for T in [float, int, long]:
        if type(x) == T or type(y) == T:
            return T(x), T(y)
    raise TypeError, "Unable to coerce %s and %s to common parent."%(x,y)
            

def bin_op(x, y, op):
    try:
        z, w = __coerce_best(x, y)
        return op(z,w)
    except TypeError:
        if hasattr(y, "is_vector") or hasattr(y,"is_matrix"):
            return op(y,x)
    raise TypeError, "Unable able to coerce %s (%s) and %s (%s) to common parent."%(
        x,type(x),y,type(y))
        
def cmp(x, y):
    if type(x) == type(None) and type(y) != type(None):
        return -1
    elif type(x) != type(None) and type(y) == type(None):
        return -1
    try:
        x, y = __coerce_best(x, y)
    except TypeError:
        return -1
    return x.__cmp__(y)
