from element import Element

class _uniq(object):
    """
    Anything that derives from this class will have at most
    one instance.
    """
    _obj = None
    def __new__(cls):
        if cls._obj != None:
            return cls._obj
        cls._obj = object.__new__(cls)
        return cls._obj
    
class Infinity(_uniq):
    def __repr__(self):
        return "Infinity"
    def __add__(self, other):
        if isinstance(other, (Element, Infinity, int, long)):
            return self
        raise errors.UsageError("%s + %s not defined."%(self, other))
    def __radd__(self, left):
        return self+left
    def __sub__(self, other):
        if isinstance(other, (Element, int, long)):
            return self
        raise errors.UsageError("%s + %s not defined."%(self, other))
    def __rsub__(self, other):
        if isinstance(other, (Element, int, long)):
            return self
        raise errors.UsageError("%s + %s not defined."%(self, other))
    def __mul__(self, other):
        if isinstance(other, Infinity):
            return self
        if isinstance(other, (Element, int, long)):
            if other == 0:
                return other
            return self
        raise errors.UsageError("%s * %s not defined."%(self, other))
    def __rmul__(self, left):
        return self*left
    def __div__(self, other):
        if isinstance(other, (Element, int, long)):
            if other != 0:
                return self
        raise errors.UsageError("%s / %s not defined."%(self, other))
    def __cmp__(self, other):
        if isinstance(other, Infinity):
            return 0
        return 1  # infinity is bigger than everything but itself
    
infinity = Infinity()

