"""
  Multivariate Polynomials

  This implementation is basically a joke, in that
  
     R=MPolynomialRing(Q,20,"x"); R.g19**2
     
  takes FOREVER. 

"""

from polynomial_ring import PolynomialRing

class MPolynomialRing(PolynomialRing):
    def __init__(self, base_ring, n=1, variable="x"):
        n = int(n)
        if n <= 0:
            raise ValueError, "Multivariate Polynomial rings must " + \
                  "have more than 0 variables."
        elif n == 1:
            base = base_ring
        else:
            base = MPolynomialRing(base_ring, n-1, variable)
        PolynomialRing.__init__(self, base,variable="%s%s"%(variable,n-1))
        self.__ngens = n
        vars = misc.add(["%s%s, "%(variable,i) for i in range(n)], "")[:-2]
        self.__repr = "Polynomial ring in %s over %s"%(vars, base_ring)


    def gen(self, n=0):
        if n < 0 or n >= self.__ngens:
            raise errors.UsageError("Generator %s not defined."%n)
        j = self.__ngens - n -1
        R = self
        for i in range(j):
            R = R.base_ring()
        return PolynomialRing.gen(R)
        
    def ngens(self):
        return self.__ngens
            
    def __repr__(self):
        return self.__repr
