"""
Power series ring

NOT DONE!
"""

import operator

from rational_field import Q
from infinity import infinity
import polynomial
import power_series_ring

Polynomial = polynomial.Polynomial_generic_dense


class PowerSeries(Polynomial):
    def __init__(self, a, x=None, prec=infinity, check=True):
        raise NotImplementedError, "Power series are currently not implemented, since I (WAS) made many changes to polynomials, and the power series implementation was based on the old version of polynomials."
        if isinstance(a, PowerSeries):   # make a copy
            x = a.trunc()
            parent = a.parent()
            prec = a.prec()
        elif isinstance(a, Polynomial):
            x = a
            R = x.parent()
            parent = power_series_ring.PowerSeriesRing(R.base_ring(),R.variable())
        else:
            parent = a
        if isinstance(x,PowerSeries):
            prec = min(prec,x.prec())
            Polynomial.__init__(self, parent, x)
        self.__repr = None
        self.__prec = prec
        if check:
            self.__normalize()

    def __cmp__(self, other):
        """
        Comparison of self and other.
        
        We say two approximate power series are equal, if they agree
        for all coefficients up to the *minimum* of the precisions of
        each.  Thus, e.g., f=1+q+O(q^2) is equal to g=1+O(q).  This is
        how PARI defines equality of power series, but not how MAGMA
        defines equality.  (MAGMA would declare f and g unequal.)  I
        side with PARI, because even if g=1+q+O(q^2), we don't really
        know whether f equals g, since we don't know the coefficients
        of q^2.

        """        
        if not isinstance(other, PowerSeries):
            return cmp(self, other)
        prec = self.__common_prec(other)
        x = self._Polynomial.list()
        y = other._Polynomial.list()
        if prec!=infinity:
            x = x[:prec]
            y = y[:prec]
        return misc.generic_cmp(x,y)

    def __normalize(self):
        x = self._Polynomial__coeffs
        n=len(x)-1
        while n>=0 and (x[n] == 0 or (self.__prec != infinity and n>=self.__prec)):
            del x[n]
            n -= 1
        self.__repr = None

    def prec(self):
        """The precision of ...+O(q^r) is r.."""
        return self.__prec

    def variable(self):
        return self.parent().variable()

    def __print_helper(self, shift):
        if self.is_zero():
            if self.prec() == infinity:
                return "0"
            else:
                return "O(%s^%s)"%(self.parent().variable(),self.prec()+shift)
        s=" "
        c = self.coeffs()
        r = range(len(c))
        X = self.parent().variable()
        seen_nonzero = False
        #if isinstance(self.base_ring(), (NumberField)):
        #    paren = True   
        #else:
        #    paren = False
        for n in r:
            x = c[n]
            if x != 0:
                if x > 0:
                    sign=operator.add
                else:
                    sign=operator.sub
                    x=-x
                if seen_nonzero:
                    s += " %s "%sign
                elif sign==operator.sub:
                    s += "%s"%sign
                #endif
                exp = n + shift
                if exp > 1 or exp <= -1:
                    var = "*%s^%s"%(X,exp)
                elif exp==1:
                    var = "*%s"%X
                else:
                    var = ""
                v = "%s"%x
                if v.find(operator.add) != -1 or v.find(operator.sub) != -1 or v.find(".") != -1:
                    v = "(%s)"%v
                s += "%s%s"%(v,var)
                seen_nonzero = True
        s=s.replace(" 1*"," ")
        s=s.replace(" -1*"," -")
        if self.__prec + shift == 0:
            bigoh = "O(1)"
        elif self.__prec + shift == 1:
            bigoh = "O(%s)"%self.parent().variable()
        else:
            bigoh = "O(%s^%s)"%(self.parent().variable(),self.__prec+shift)
        if self.__prec != infinity:
            if s==" ":
                return bigoh
            s += " + %s"%bigoh
        #else:
        #    s += " + ..."
        return s[1: ]

    def __repr__(self):
        if self.__repr != None:
            return self.__repr
        self.__repr = self.__print_helper(0)
        return self.__repr
    
    def copy(self):
        return PowerSeries(self.parent(), list(self.coeffs()), self.prec())

    def randomize(self, degree, bound=10):
        Polynomial.randomize(self, degree, bound)
        self.__prec = infinity
        self.__normalize()

    def trunc(self, prec=infinity):
        """
        Polynomial obtained from power series by truncating.
        """
        if prec == infinity:
            prec = self.__prec
        a = self.coeffs()
        v = [a[i] for i in range(min(prec, len(a)))]
        return polynomial.Polynomial(polynomial.PolynomialRing(self.base_ring(),self.variable()), v)

    def add_bigoh(self, prec):
        """
        Returns the power series of precision at most prec got by
        adding O(q^prec) to f, where q is the variable.
        """
        if prec == infinity or prec >= self.prec():
            return
        return PowerSeries(self.parent(), self.trunc(prec), prec)
        
    def __getitem__(self,n):
        if n<0:
            return 0
        c = self.coeffs()
        if n >= len(c):
            if self.__prec > n:
                return self.base_ring()(0)
            else:
                raise IndexError, "Coefficient %s not known."%n
        return self._Polynomial__coeffs[n]
    
    def __getslice__(self, i, j):
        if j>self.prec():
            raise IndexError, "Coefficients %s and beyond not known."%self.prec()
        return polynomial.Polynomial.__getslice__(self, i, j)
    
    def __setitem__(self, n, value):
        polynomial.Polynomial.__setitem__(self, n, value)
        self.__prec = max(self.__prec, n+1)
        self.__repr = None
        
    def __common_prec(self, x):
        if self.prec() == infinity:
            return x.prec()
        elif x.prec() == infinity:
            return self.prec()
        return min(self.prec(),x.prec())
    
    def __add__(self, right):
        if not isinstance(right,PowerSeries) or self.parent() != right.parent():
            return bin_op(self, right, operator.add)
        x = polynomial.Polynomial.__add__(self,right)
        return PowerSeries(self.parent(), x, self.__common_prec(right))
    
    def __radd__(self, left):
        return self.parent()(left) + self
    
    def __mul__(self, right):
        if not isinstance(right,PowerSeries) or self.parent() != right.parent():
            return bin_op(self, right, operator.mul)
        if self.is_zero():
            return self
        if right.is_zero():
            return right
        sp = self.prec()
        rp = right.prec()
        if sp == infinity:
            if rp == infinity:
                prec = infinity
            else:
                prec = rp + self.valuation()
        else:  # sp != infinity
            if rp == infinity:
                prec = sp + right.valuation()
            else:
                prec = min(rp + self.valuation(), sp + right.valuation())
        # endif
        return PowerSeries(self.parent(), polynomial.Polynomial.__mul__(self,right), prec)
    
    def __rmul__(self, left):
        return self.parent()(left) * self
    
    def __invert__(self):
        """Inverse of the power series, which we assume to have
        nonzero constant term so that the inverse is again a
        power series."""
        if self.valuation() > 0:
            u = ~self.unit_part()  # inverse of unit part
            R = LaurentSeriesRing(self.base_ring(),self.variable())
            return LaurentSeries(R, u, -self.valuation())
        a0 = self[0]
        try:
            b = [a0**(-1)]
        except:
            raise ZeroDivisionError, "leading coefficient must be a unit."
        #  By multiplying through we may assume that the leading coefficient
        #  of f=self is 1.   If f = 1 + a_1*q + a_2*q^2 + ..., then we have
        #  the following recursive formula for the coefficients b_n of the
        #  expansion of f^(-1):
        #        b_n = -b_0*(b_{n-1}*a_1 + b_{n-2}*a_2 + ... + b_0 a_n).
        a = self.coeffs()
        for n in range(1,len(a)):
            b.append(-b[0]*sum([b[n-i]*a[i] for i in range(1,n+1)]))
        return PowerSeries(self.parent(), x=b, prec=self.prec())
    
    def unit_part(self):
        """
        Suppose self factors as q^n*(a_0 + a_1*q + ...) with a_0 nonzero.  Then
        this function returns a_0 + a_1*q + ...

        unit_part():

        """
        assert not self.is_zero(), "Argument must be nonzero to have a unit part."
        n = self.valuation()
        coeffs = self._Polynomial__coeffs[n:]
        return PowerSeries(self.parent(), coeffs, self.prec()-n)
    
    def __div__(self, denom):
        if not isinstance(denom, PowerSeries) or self.parent() != denom.parent():
            return bin_op(self, denom, operator.div)

        u = denom.unit_part()
        inv = ~u  # inverse
        
        # Algorithm: Cancel common factors of q from top and bottom,
        # then invert the denominator.  We do the cancellation first
        # because we can only invert a unit (and remain in the ring
        # of power series).
        
        v = denom.valuation()
        if v > self.valuation():
            return LaurentSeries(self)/LaurentSeries(denom)
        
        u = denom.unit_part()
        if v > 0:
            coeffs = self._Polynomial__coeffs[v:]
            num = polynomial.PowerSeries(self.parent(), coeffs, self.prec()-v)
        else:
            num = self
        return num*inv
    
    
    def __rdiv__(self, left):
        return self.parent()(left) / self
    
    def __pow__(self, right):
        right=int(right)
        if right < 0:
            return (~self)**(-right)
        if right == 0:
            return self.parent()(1)
        if self.is_zero():
            return self
        if self.valuation() == 1 and self.degree() == 1:   # alpha*q 
            v = [0 for _ in range(right)]
            v.append(self[1]**right)
            return PowerSeries(self.parent(), v, prec=self.prec()+right-1)
        return arith.generic_power(self, right)
    
    def __mod__(self, other):
        if isinstance(other,(int,Integer,long)):
            try:
                return power_series_ring.PowerSeriesRing(Zmod(other))(self)
            except:
                pass
        # todo: it *should* be defined, and also on polynomials!!!
        raise errors.UsageError("Mod on power series ring not defined.")
    
    def O(self, prec):
        """Return self + O(q**prec), computed quickly.  Does not change self."""
        if prec==infinity or prec >= self.prec():
            return self
        coeffs = self._Polynomial__coeffs[:prec]
        return PowerSeries(self.parent(), coeffs, prec)

    def exp(self, prec=infinity):
        if prec == infinity:
            assert self.prec() != infinity, "must set prec for exponentiation " + \
                   "of infinite-precision power series"
            prec = self.prec()
        assert self.valuation() >= 1, "valuation must be positive"
        x = PowerSeries(self.parent(), list(self.coeffs()), prec)
        ans = self.parent()(1)
        for n in range(1,prec):
            ans += x/arith.factorial(n)
            x *= self
        return PowerSeries(self.parent(), x=ans, prec=prec)

    def denominator(self):
        if self.base_ring() == rings.Q:
            return arith.LCM([a.denominator() for a in self.coeffs()])
        raise NotImplementedError

    def V(self, n):
        """If f = sum a_m*q^m, then this function returns sum a_m*q^(n*m)."""
        v = self.coeffs()
        m = 0
        w = []
        zero = self.base_ring()(0)
        for i in range(len(v)*n):
            if i%n != 0:
                w.append(zero)
            else:
                w.append(v[m])
                m += 1
        return PowerSeries(self.parent(), w, self.prec()*n)



