"""
Tables.

   * jones() -- returns the John Jones table of number fields
                with bounded ramification and degree <= 6.
                
   * elliptic_curves() -- extended table of elliptic curves
                based on Cremona's data
                
   * gamma0wt2() -- table of arithmetic informationa about
                newforms of weight 2 on Gamma_0(N).
"""

#*****************************************************************************
#       SAGE: System for Arithmetic Geometry Experimentation
#
#       Copyright (C) 2005 William Stein <was@math.harvard.edu>
#
#  Distributed under the terms of the GNU General Public License (GPL)
#
#    This code is distributed in the hope that it will be useful,
#    but WITHOUT ANY WARRANTY; without even the implied warranty of
#    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
#    General Public License for more details.
#
#  The full text of the GPL is available at:
#
#                  http://www.gnu.org/licenses/
#*****************************************************************************


from sage.tables.jones import Database as jones
from sage.tables.elliptic_curves import Database as elliptic_curves
from sage.tables.gamma0wt2 import Database as gamma0wt2


